/*
the data structure file to hold I/O configuration; has to agree to mdb file 
*/

#ifndef DEF_IO_DATA__
#define DEF_IO_DATA__

typedef struct IoDef 
{
	int8_t	pinNo;		//pin number
	char	devName[50];	//device name(switch, pd, etc.)
	int16_t	devID;		//device ID(switch id, pd id, etc.)

	char	devType;	//type of device(switch, PD, Misc, signal)
	char	devSubType;	//subtype of device(normal, reverse, etc.)

	char	devHighLow;	//high true or low true

	char	devIoType;	//input or output: o: leveled out; i:level in; I:pulse in; a:analog in
} IO_DEF_DATA;
#endif
