/*
	get software version from file
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h> /* for strncpy */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>

int main()
{
	FILE *fp;
	char version[20];
	int number = 0;
	memset(&version, 0x0, sizeof(char) * 20);

	if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_version.txt", "r")) == NULL)
	{
		printf("-1");//open fail
		return -1;
	}
	else
	{
		number = fread(version, sizeof(char), 20, fp);
		//printf("number = %d", number);
		//printf("version = %s", version);
	}
	fclose(fp);

	printf("Content-Type: text/html\n\n");
	printf("%s", version);

	return 0;
}
