#include <stdio.h>
#include <unistd.h>
#include <string.h> /* for strncpy */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>
#include "include/DefIo.h"

#define MAX_NUM_IO		24	//max io number in dio24
IO_DEF_DATA ioDef[MAX_NUM_IO];

int main()
{
	char *date;
	char a[504][50];
	memset(a, 0x0, sizeof(a));
	int tempInt = 0;
	int i,j;

	printf("Content-Type: text/html\n\n");

	date = (char *)getenv("CONTENT_LENGTH");

	int len = atoi(getenv("CONTENT_LENGTH"));

	if(date == NULL || len < 1)
	{
		printf("fail");
	}
	else
	{
		char tmp[50000];
		memset(tmp, 0x0, sizeof(tmp));
		int index = 0;
		
		fgets(tmp, len + 1, stdin);

		/*if(sscanf(&tmp, "port=%s", &a) == -1)
		{
			printf("-10");
			return 0;
		}*/

		char *result;
		result = strtok(tmp, "||");
		while(result != NULL)
		{
			if(strstr(result, "-999") != NULL)
			{
				tempInt = atoi(result);
				if(tempInt != -999)
				{
					strcpy(a[index], result);
				}
			}
			else
			{
				strcpy(a[index], result);
			}

			result = strtok(NULL, "||");
			index++;
		}

		//save io
		index = 0;
		for(i = 0; i < 24; i++)
		{
			sprintf(ioDef[i].devName, "%s", a[index]);
			index++;

			ioDef[i].devID = (short)atoi(a[index]);
			index++;

			ioDef[i].devSubID = (short)atoi(a[index]);
			index++;

			ioDef[i].devType = *(a[index] + 0);
			index++;

			ioDef[i].devSubType = *(a[index] + 0);
			index++;

			ioDef[i].devNode = (short)atoi(a[index]);
			index++;

			ioDef[i].devBoard = (short)atoi(a[index]);
			index++;

			ioDef[i].devByte = (short)atoi(a[index]);
			index++;

			ioDef[i].devBit = (short)atoi(a[index]);
			index++;

			ioDef[i].devHighLow = toupper(*(a[index] + 0));
			index++;

			ioDef[i].devIoType = *(a[index] + 0);
			index++;

			ioDef[i].devIoSubType = *(a[index] + 0);
			index++;

			ioDef[i].devIoFamily = *(a[index] + 0);
			index++;

			ioDef[i].devTime = (short)atoi(a[index]);
			index++;

			ioDef[i].devSlowTime = (short)atoi(a[index]);
			index++;

			ioDef[i].serialNo = (short)atoi(a[index]);
			index++;

			ioDef[i].devMade = *(a[index] + 0);
			index++;

			/*ioDef[i].mode = (short)atoi(a[index]);
			index++;

			ioDef[i].board = (short)atoi(a[index]);
			index++;

			ioDef[i].input = (short)atoi(a[index]);
			index++;

			ioDef[i].channel = (short)atoi(a[index]);
			index++;*/
		}


		FILE *fp;
		if((fp = fopen("/home/flexyard/flexyard/sysconfig/IoConfig4.dat", "w")) == NULL)
		{
			printf("-1");//open fail
			return -1;
		}
		else
		{
			//if(fwrite(&tmp, sizeof(tmp), 1, fp) != 1)
			//if(fwrite(&a, sizeof(a), 1, fp) != 1)
			if(fwrite((char *)ioDef, MAX_NUM_IO * sizeof(IO_DEF_DATA), 1, fp) != 1)
			{
				printf("-2");//write fail
			}
			else
			{
				printf("1");//success
				//printf("len=%d %s", len, date);
			}
		}
		fclose(fp);
	}

	//printf("%s\n", "test123");

	return 0;
}
