/*
	Radio Structure
*/

#ifndef DEF_RADIO_DATA__
#define DEF_RADIO_DATA__

typedef struct Radio
{
	char enable;		//Enable Radio Function(E=enable, D=disable)
	char LPO;		//Local Pushbutton Override(A=Never, B=During Comm Failure, C=Always)
	int16_t TRBT;		//Rx Broadcast Timeout(second)
	double TTID;		//Tx Inter-message Delay(second)
	int16_t TRCL;		//Remote Control Lockout(minute)
	int16_t TPCL;		//Pushbutton Control Lockout Timeout(minute)
	char enableAC;		//Enable Autonomous Comunication(E=enable, D=disable)
	int16_t ACTBP;		//Automomous Communication Timer: Tx Broadcast Period(second)
	int16_t ACRT;		//Automomous Communication Timer: Rx Timeout(second)
}RADIO_FUNC_DATA;
#endif

