/*
	save ip to file
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h> /* for strncpy */
#include <stdlib.h>
#include <time.h>
#include <sys/time.h>
#include <errno.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>

int main()
{
	char *data;
	char *p;
	int result = -1, result1 = 0;

	char timestr[50];
	char command[100];
	char year[4];
	char month[2];
	char date[2];
	char hour[2];
	char minute[2];
	char second[2];
	char type[2];
	char type_time[2];
	char dataTemp[100];

	memset(timestr, 0x0, sizeof(char) * 50);
	memset(command, 0x0, sizeof(char) * 100);
	memset(dataTemp, 0x0, sizeof(dataTemp));

	printf("Content-Type: text/html\n\n");

	data = (char *)getenv("QUERY_STRING");
	if(data == NULL)
	{
		printf("fail");
	}
	else
	{
		sscanf(data, "type=%1s", dataTemp);

		if(dataTemp[0] == 'T')
		{
			p = strtok(data, "&=");
			while(p != NULL)
			{
				if(0 == strcmp(p, "p1"))
				{
					p = strtok(NULL, "&=");
					type_time[0] = p[0];
					//printf("%s", type_time);
				}
				else if(0 == strcmp(p, "p2"))
				{
					p = strtok(NULL, "&=");
					sprintf(year, "%s", p);
					//printf("%s", year);
				}
				else if(0 == strcmp(p, "p3"))
				{
					p = strtok(NULL, "&=");
					sprintf(month, "%s", p);
					//printf("%s", month);
				}
				else if(0 == strcmp(p, "p4"))
				{
					p = strtok(NULL, "&=");
					sprintf(date, "%s", p);
					//printf("%s", date);
				}
				else if(0 == strcmp(p, "p5"))
				{
					p = strtok(NULL, "&=");
					sprintf(hour, "%s", p);
					//printf("%s", hour);
				}
				else if(0 == strcmp(p, "p6"))
				{
					p = strtok(NULL, "&=");
					sprintf(minute, "%s", p);
					//printf("%s", minute);
				}
				else if(0 == strcmp(p, "p7"))
				{
					p = strtok(NULL, "&=");
					sprintf(second, "%s", p);
					//printf("%s", second);
				}
				p = strtok(NULL, "&=");
			}
		}

		FILE *fp;
		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_time.txt", "w")) == NULL)
		{
			printf("-1");//open fail
			return -1;
		}
		else
		{
			result = 1;

			//save time
			sprintf(timestr, "%4s-%2s-%2s %2s:%2s:%2s", year, month, date, hour, minute, second);
			sprintf(command, "sudo /bin/date --set \'%s\'", timestr);

			int bbb = system(command);
			bbb = system("/usr/lib/cgi-bin/configbin/settime.sh");
//printf("%d %s", bbb, strerror(errno));
//return;

			//save type
			//strcat(type_time, "#time function 1=manual set time; 2=time from NX system\n");
			result1 = fwrite(&type_time, sizeof(type_time), 1, fp);
			if(result1 != 1)
			{
				result = -1;
			}
		}
		fclose(fp);
	}

	//printf("%s", timestr);
	printf("%d", result);

	return 0;
}
